unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    btnClose: TButton;
    Button2: TButton;
    Button4: TButton;
    Panel1: TPanel;
    lbBlkNames: TListBox;
    ckbIncSpecBlocks: TCheckBox;
    Button3: TButton;
    Button6: TButton;
    Button7: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses UAutoCAD;

{$R *.dfm}

procedure ExtractSameBlockAttr(AFileName: string);
var
  BasePnt, BlkRef: OleVariant;
  Entity: IDispatch;
begin
  if not VarIsClear(Acad) then
  begin
    try
      Acad.ActiveDocument.Utility.GetEntity(Entity, BasePnt, ' : ');
      BlkRef:= Entity;
    except
      raise Exception.Create(' ');
    end;
    ExtractBlkRefAttr(BlkRef, AFileName);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  AcConnect(rsDefClassName, False, True);
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ExtractSameBlockAttr('c:\attr.txt');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  EnumBlockNames(lbBlkNames.Items, ckbIncSpecBlocks.Checked);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ExtractBlockAttr('c:\attr.txt');
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  BlockName: string;
  BlkRef, InsPnt: OleVariant;
begin
  if not VarIsClear(Acad) and (lbBlkNames.ItemIndex >= 0) then
  begin
    InsPnt:= Acad.ActiveDocument.Utility.GetPoint(, '  : ');
    with lbBlkNames do
      BlockName:= Items[ItemIndex];
    BlkRef:= Acad.ActiveDocument.ModelSpace.InsertBlock(InsPnt, BlockName, 1, 1, 1, 0);
    BlkRef.Update;
  end;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  BlockName: string;
  Block, BlkRef: OleVariant;
begin
  if not VarIsClear(Acad) then
  begin
    BlockName:= 'New Block';
    //      
    Block:= Acad.ActiveDocument.Blocks.Add(AcadPoint(0, 0), BlockName);
    //       
    Block.AddLine(AcadPoint(0, 0), AcadPoint(10, 10));
    Block.AddLine(AcadPoint(10, 10), AcadPoint(-10, 10));
    Block.AddLine(AcadPoint(-10, 10), AcadPoint(0, 0));
    //   
    EnumBlockNames(lbBlkNames.Items, ckbIncSpecBlocks.Checked);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  BlockName: string;
  Block, BlkRef: OleVariant;
begin
  if not VarIsClear(Acad) then
  begin
    BlockName:= 'New Attr Block';
    //      
    Block:= Acad.ActiveDocument.Blocks.Add(AcadPoint(0, 0), BlockName);
    //       
    Block.AddLine(AcadPoint(0, 0), AcadPoint(10, 10));
    Block.AddLine(AcadPoint(10, 10), AcadPoint(-10, 10));
    Block.AddLine(AcadPoint(-10, 10), AcadPoint(0, 0));
    //  : Height, Mode, Prompt, AttInsPoint, Tag, Value
    Block.AddAttribute(5, acAttributeModePreset, '', AcadPoint(0, 10), 'TAG', 'DefVal');
    //   
    EnumBlockNames(lbBlkNames.Items, ckbIncSpecBlocks.Checked);
  end;
end;

end.
 